Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Classes | Public Member Functions | Static Public Member Functions | List of all members
stk::Skini Class Reference

STK SKINI parsing class. More...

`#include <Skini.h>`

Inheritance diagram for stk::Skini:

## Classes

struct | Message
| A message structure to store and pass parsed SKINI messages. More...

## Public Member Functions

| Skini ()
| Default constructor.
| ~Skini ()
| Class destructor.
bool | setFile (std::string fileName)
| Set a SKINI formatted file for reading.
long | nextMessage (Skini::Message &message)
| Parse the next file message (if a file is loaded) and return the message type.
long | parseString (std::string &line, Skini::Message &message)
| Attempt to parse the given string and returning the message type.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Static Public Member Functions

static std::string | whatsThisType (long type)
| Return the SKINI type string for the given type value.
static std::string | whatsThisController (long number)
| Return the SKINI controller string for the given controller number.
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.

## Additional Inherited Members

Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK SKINI parsing class.

This class parses SKINI formatted text messages. It can be used to parse individual messages or it can be passed an entire file. The SKINI specification is Perry's and his alone, but it's all text so it shouldn't be too hard to figure out.

SKINI (Synthesis toolKit Instrument Network Interface) is like MIDI, but allows for floating-point control changes, note numbers, etc. The following example causes a sharp middle C to be played with a velocity of 111.132:

noteOn 60.01 111.132

See also
  Synthesis toolKit Instrument Network Interface (SKINI)

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ setFile()

bool stk::Skini::setFile | ( | std::string | fileName | ) |

Set a SKINI formatted file for reading.

If the file is successfully opened, this function returns true. Otherwise, false is returned.

## ◆ nextMessage()

long stk::Skini::nextMessage | ( | Skini::Message & | message | ) |

Parse the next file message (if a file is loaded) and return the message type.

This function skips over lines in a file which cannot be parsed. A type value equal to zero in the referenced message structure (and the returned value) indicates the file end is reached or no file is open for reading.

## ◆ parseString()

long stk::Skini::parseString | ( | std::string & | line,
|  | Skini::Message & | message )

Attempt to parse the given string and returning the message type.

A type value equal to zero in the referenced message structure indicates an invalid message.

The documentation for this class was generated from the following file:

- Skini.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.